{* template javascript header for google Map API V2 *}
<script type="text/javascript">
var jGmap = Class.extend({ldelim}
	{* properties *}
	map:{ldelim}{rdelim},
	centerPoint: {ldelim}
		lat:0,
		lng:0
	{rdelim},
	minPoint: {ldelim}
		lat:0,
		lng:0
	{rdelim},
	maxPoint: {ldelim}
		lat:0,
		lng:0
	{rdelim},
	backgroundColor:'{$map->mapBackgroundColor }',
	{* map's display parameters *}
	mapOptions:{ldelim}
	{assign $counter = 1}
	{assign $length = count($map->mapOptions)}
	{foreach $map->mapOptions as $mapOption => $mapOptionOK}
		{$mapOption}:{if $mapOptionOK}true{else}false{/if}{if $counter<$length},{/if}
		{assign $counter = $counter + 1}
	{/foreach}
	{rdelim},
	mapControl:{if $map->mapControl}true{else}false{/if},
	mapControlType:{$map->mapControlType},
	scaleControl:{if $map->scaleControl}true{else}false{/if},
	overviewMapControl:{if $map->overviewMapControl}true{else}false{/if},
	keyboardHandler:{if $map->keyboardHandler}true{else}false{/if},
	mapTypeControl:{if $map->mapTypeControl}true{else}false{/if},
	mapType:'{$map->mapType}',
	mapTypes:{ldelim}
	{assign $counter = 1}
	{assign $length = count($map->mapTypes)}
	{foreach $map->mapTypes as $mapType => $mapTypeOK}
		{$mapType}:{if $mapTypeOK}true{else}false{/if}{if $counter<$length},{/if}
		{assign $counter = $counter + 1}
	{/foreach}
	{rdelim},
	mapTypeControlStyle:{$map->mapTypeControlStyle},

	// constructor
	init:function(domId,mapOpts) {ldelim}
		if (google.maps.BrowserIsCompatible()) {ldelim}
			this.map = new google.maps.Map2(jQuery("#"+domId).get(0),{ldelim}'backgroundColor':this.backgroundColor{rdelim});
			// init all map's options
			for (opts in mapOpts) {ldelim}
				this[opts] = mapOpts[opts];
			{rdelim}
		{rdelim} else {ldelim}
			alert("{@jgmap~gmap.browser.alert@}");
		{rdelim}
	{rdelim},
	customizeMap: function() {ldelim}
		{* map's options *}
		for (var mapOption in this.mapOptions) {ldelim}
			if (this.mapOptions[mapOption]) {ldelim}
				eval("this.map.enable"+mapOption+"();");
			{rdelim} else {ldelim}
				eval("this.map.disable"+mapOption+"();");
			{rdelim}
		{rdelim}
		{* map's control type *}
		if (this.mapControlType=={$map->getSmallMapControl()})
			this.map.addControl(new google.maps.SmallMapControl());
		else if (this.mapControlType=={$map->getLargeMapControl()})
			this.map.addControl(new google.maps.LargeMapControl());
		else if (this.mapControlType=={$map->getLarge3DMapControl()})
			this.map.addControl(new google.maps.LargeMapControl3D());
		else if (this.mapControlType=={$map->getSmallZoomControl()})
			this.map.addControl(new google.maps.SmallZoomControl3D());
		else if (this.mapControlType=={$map->getSmallZoom3DControl()})
			this.map.addControl(new google.maps.SmallZoomControl3D());
		{* scale control *}
		if (this.scaleControl)
			this.map.addControl(new google.maps.ScaleControl());
		{* overview map control *}
		if (this.overviewMapControl)
			this.map.addControl(new google.maps.OverviewMapControl());
		{* keyboard handler *}
		if (this.keyboardHandler)
			new google.maps.KeyboardHandler(this.map);
		{* mapType control *}
		if (this.mapTypeControl) {ldelim}
			eval("this.map.setMapType(google.maps."+this.mapType+");");
			for (var mapType in this.mapTypes) {ldelim}
				if (this.mapTypes[mapType]) {ldelim}
					eval("this.map.addMapType(google.maps."+mapType+");");
				{rdelim} else {ldelim}
					eval("this.map.removeMapType(google.maps."+mapType+");");
				{rdelim}
			{rdelim}
			if (this.mapTypeControlStyle == 1)
				this.map.addControl(new google.maps.MenuMapTypeControl());
			else
				this.map.addControl(new google.maps.MapTypeControl());
		{rdelim}
	{rdelim},
	createMarker: function(latlng,markerOpts) {ldelim}
		var marker = new google.maps.Marker(latlng,markerOpts);
		if (markerOpts.clickable) {ldelim}
			google.maps.Event.addListener(marker, 'click', function(latlng) {ldelim} this.showCoords(latlng); {rdelim}); 
		{rdelim}
		if (markerOpts.draggable) {ldelim}
			google.maps.Event.addListener(marker, 'dragend', function(latlng) {ldelim} this.showCoords(latlng); {rdelim}); 
		{rdelim}
		{* create new method in google map marker object *}
		marker.showCoords = function(latlng) {ldelim}
				var windowOpts = {ldelim}'maxWidth':400,'maxHeight':200,'autoScroll':true,'noCloseOnClick':false{rdelim};
				var coordsText = '<p>lat : '+latlng.lat() + '<br/> lon : '+latlng.lng()+'</p>';
				this.openInfoWindowHtml(coordsText,windowOpts);
			{rdelim}
		this.map.addOverlay(marker);
	{rdelim},
	createIcon: function(params) {ldelim}
		var icon = new google.maps.Icon();
		icon.image = params.image;
		icon.shadow = params.shadow;
		icon.iconSize = params.iconSize;
		icon.iconAnchor = params.iconAnchor;
		icon.infoWindowAnchor = params.infoWindowAnchor;
		return icon;
	{rdelim},
	adjustCenterZoom: function() {ldelim}
		var centerLatLng = new google.maps.LatLng(this.centerPoint.lat,this.centerPoint.lng);
		this.map.setCenter(centerLatLng);
		var bounds = new GLatLngBounds(new GLatLng(this.minPoint.lat, this.minPoint.lng), 
									   new GLatLng(this.maxPoint.lat, this.maxPoint.lng));
		this.map.setZoom(this.map.getBoundsZoomLevel(bounds));
	{rdelim}
{rdelim});
</script>
